package main;

import person.Gender;
import person.NameFirstYearLastPersonComparator;
import person.Person;

import java.util.*;

public class PersonTest {

    private static final Person AGENT_SMITH = Person.makePerson("Agent", "Smith", "agent", Gender.MALE, 2035);
    private static final Person TRINITY = Person.makePerson("Trinity", "Trin", "hacker", Gender.FEMALE, 2031);
    private static final Person NEO = Person.makePerson("Thomas", "Anderson", "redeemer", Gender.MALE, 2029);

    private static final Person CLONE_OF_SMITH_A = Person.makePerson("Agent", "Smith", "agent", Gender.MALE, 2035);
    private static final Person CLONE_OF_SMITH_B = Person.makePerson("Agent", "Smith", "agent", Gender.MALE, 2035);

    public static void main(String[] args) {
        List<Person> matrixCharacters = Arrays.asList(AGENT_SMITH, TRINITY, NEO, CLONE_OF_SMITH_A, CLONE_OF_SMITH_B);
        testSortByComparable(matrixCharacters);
        testSortByComparator(matrixCharacters, new NameFirstYearLastPersonComparator());
    }

    private static void testSortByComparable(List<Person> persons) {
        System.out.println("--- sort by using Comparable ---");
        List<Person> copyOfPersons = new ArrayList<>(persons);
        Collections.sort(copyOfPersons);
        printAll(copyOfPersons);
    }

    private static void testSortByComparator(List<Person> persons, Comparator<Person> comparator) {
        System.out.println("--- sort by using custom Comparator ---");
        List<Person> copyOfPersons = new ArrayList<>(persons);
        Collections.sort(copyOfPersons, comparator);
        printAll(copyOfPersons);
    }

    private static void testSet() {
        System.out.println("--- set ---");
        Set<Person> matrixCharacters = new HashSet<>();
        matrixCharacters.add(AGENT_SMITH);
        printAll(matrixCharacters);
        matrixCharacters.add(AGENT_SMITH);
        printAll(matrixCharacters);
        matrixCharacters.add(CLONE_OF_SMITH_A);
        printAll(matrixCharacters);
        matrixCharacters.add(CLONE_OF_SMITH_B);
        printAll(matrixCharacters);
        matrixCharacters.add(TRINITY);
        printAll(matrixCharacters);
    }

    private static <T> void printAll(Collection<T> collection) {
        for (T element : collection) {
            System.out.println(element);
        }
    }
}